import spirecloudpdf
from spirecloudpdf import Color, RectangleF, AnnotationBorder, PointF, FreeTextAnnotation, Font, FreeTextAnnotations
from spirecloudpdf.configuration import Configuration as PdfConfiguration

appId = "your id"
appKey = "your key"
baseUrl="https://api.e-iceblue.cn"
configuration = PdfConfiguration(appId, appKey,baseUrl)
api = spirecloudpdf.api.pdf_annotation_api.PdfAnnotationApi(configuration)

name = "Sample.pdf"
outputPath = "Annotation/AddFileTextAnnotation.pdf"
inputFolder = "PdfDocument"
pageNumber = 1
password = None
storage = None
border1 = AnnotationBorder(0.5, 0.0, 0.0)
border2 = AnnotationBorder(5, 2, 2)
point1 = PointF(150, 50)
point2 = PointF(155, 45)
point3 = PointF(160, 40)
calloutLines = [point1, point2, point3]
rectangleDifferences = [20, 20, 5, 5]
annotation1 = FreeTextAnnotation(Color(255, 225, 225, 255), "Free text annotation test 1", None, "Invisible",
                                         "FreeTextAnnotation1", RectangleF(160, 40, 40, 12), 1, border1,
                                         "E-iceblue", Font("Standard", "Helvetica", 8, "Italic"),
                                         Color(1, 65, 105, 225), Color(255, 0, 0, 0), None, None, 0.7, calloutLines,
                                         None)
annotation2 = FreeTextAnnotation(Color(255, 245, 222, 179), "Free text annotation test 2", None, "Invisible",
                                         "FreeTextAnnotation2", RectangleF(50, 50, 100, 100), 1, border2,
                                         "E-iceblue", Font("Standard", "Helvetica", 12, "Bold"), Color(100, 0, 255, 0),
                                         Color(255, 0, 0, 0), "Slash", "FreeTextTypeWriter", 1, None,
                                         rectangleDifferences)
annotationList = [annotation1, annotation2]
freeTextAnnotations = FreeTextAnnotations(annotationList)
api.add_free_text_annotation(name, outputPath, pageNumber, freeTextAnnotations, folder=inputFolder,storage=storage,password=password)