import spirecloudpdf
from spirecloudpdf import Color, RectangleF, Destination, LinkAnnotation, GoToAction, LaunchAction, URIAction, NamedAction, EmbeddedGoToAction, LinkAnnotations
from spirecloudpdf.configuration import Configuration as PdfConfiguration

appId = "your id"
appKey = "your key"
baseUrl="https://api.e-iceblue.cn"
configuration = PdfConfiguration(appId, appKey,baseUrl)
api = spirecloudpdf.api.pdf_annotation_api.PdfAnnotationApi(configuration)

name = "Sample.pdf"
outputPath = "Annotation/AddLinkAnnotation.pdf"
inputFolder = "PdfDocument"
pageNumber = 1
password = None
dest1 = Destination(1, 1, "FitToPage", None, RectangleF(50, 50, 500, 500))
annotation1 = LinkAnnotation(Color(100, 255, 0, 0), "Link annotation test 1", None, "Default",
                                     "LinkAnnotation1", RectangleF(50, 50, 50, 50), None, None, "Invert", "GoToAction",
                                     GoToAction(dest1), None, None, None, None, None, None)

dest2 = Destination(2, 2, "FitToPage", None, RectangleF(50, 50, 500, 500))
annotation2 = LinkAnnotation(Color(100, 0, 0, 255), "Link annotation test 2", None, "Default",
                                     "LinkAnnotation2", RectangleF(50, 150, 50, 50), None, None, "Outline",
                                     "GoToAction", GoToAction(dest2), None, None, None, None, None, None)

launchAction = LaunchAction("/PdfDocument/Image.pdf", True)
annotation3 = LinkAnnotation(Color(100, 0, 255, 0), "Link annotation test 3 LaunchAction", None, "Default",
                                     "LinkAnnotation3", RectangleF(50, 300, 50, 50), None, None, "Invert",
                                     "LaunchAction", None, None, None, launchAction, None, None, None)

uriAction = URIAction("https://www.baidu.com")
annotation4 = LinkAnnotation(Color(100, 0, 255, 0), "Link annotation test 4 URIAction", None, "Default",
                                     "LinkAnnotation4", RectangleF(300, 50, 50, 50), None, None, "Invert", "URIAction",
                                     None, None, None, None, None, None, uriAction)

namedAction = NamedAction("NextPage")
annotation5 = LinkAnnotation(Color(100, 0, 255, 0), "Link annotation test 5 NamedAction", None, "Default",
                                     "LinkAnnotation5", RectangleF(300, 150, 50, 50), None, None, "Invert",
                                     "NamedAction", None, None, None, None, namedAction, None, None)

embeddedGoToAction = EmbeddedGoToAction(dest2, "/PdfDocument/Annotation.pdf", True)
annotation6 = LinkAnnotation(Color(100, 0, 255, 0), "Link annotation test 6 EmbeddedGoToAction", None,
                                     "Default", "LinkAnnotation6", RectangleF(300, 300, 50, 50), None, None, "Invert",
                                     "EmbeddedGoToAction", None, embeddedGoToAction, None, None, None, None, None)

annotationList = [annotation1, annotation2, annotation3, annotation4, annotation5, annotation6]
linkAnnotations = LinkAnnotations(annotationList)
api.add_link_annotation(name, outputPath, pageNumber, linkAnnotations, folder=inputFolder, password=password)