import spirecloudpdf
from spirecloudpdf import Color, RectangleF, PointF, Font,  AnnotationApperanceText, AnnotationApperanceImage, AnnotationApperance, \
    PopupAnnotation, PopupAnnotations
from spirecloudpdf.configuration import Configuration as PdfConfiguration

appId = "your id"
appKey = "your key"
baseUrl="https://api.e-iceblue.cn"
configuration = PdfConfiguration(appId, appKey,baseUrl)
api = spirecloudpdf.api.pdf_annotation_api.PdfAnnotationApi(configuration)

name = "Sample.pdf"
outputPath = "Annotation/AddPopupAnnotation.pdf"
inputFolder = "PdfDocument"
pageNumber = 1
password = None
text = AnnotationApperanceText("This is a test! ", Font("Standard", "Helvetica", 12, "Bold"),
                                       RectangleF(10, 10, 80, 20), None, Color(255, 0, 0, 0))
image = AnnotationApperanceImage(PointF(50, 50), "Attachment.jpg")
apperance = AnnotationApperance(100, 100, text, image)
annotation1 = PopupAnnotation(Color(100, 255, 0, 0), "Popup annotation test 1", None, None, "PopupAnnotation1",
                                      RectangleF(50, 50, 100, 100), 1, None, None, None)

annotation2 = PopupAnnotation(Color(100, 0, 0, 255), "Popup annotation test 2", None, None, "PopupAnnotation2",
                                      RectangleF(50, 350, 500, 50), 1, None, None, None, apperance, None, None)

annotationList = [annotation1, annotation2]
popupAnnotations = PopupAnnotations(annotationList)
api.add_popup_annotation(name, outputPath, pageNumber, popupAnnotations, folder=inputFolder, password=password)