import spirecloudpdf
from spirecloudpdf import Color, RectangleF, PointF, Font, AnnotationApperanceText, AnnotationApperanceImage, AnnotationApperance, RubberStampAnnotations, RubberStampAnnotation
from spirecloudpdf.configuration import Configuration as PdfConfiguration

appId = "your id"
appKey = "your key"
baseUrl="https://api.e-iceblue.cn"
configuration = PdfConfiguration(appId, appKey,baseUrl)
api = spirecloudpdf.api.pdf_annotation_api.PdfAnnotationApi(configuration)

name = "Sample.pdf"
outputPath = "Annotation/AddRubberStampAnnotation.pdf"
inputFolder = "PdfDocument"
pageNumber = 1
password = None
text1 = AnnotationApperanceText("Test Normal! ", Font("Standard", "Helvetica", 12, "Bold"),
                                        RectangleF(10, 10, 80, 20), None, Color(255, 0, 0, 0))
text2 = AnnotationApperanceText("Test MouseHover! ", Font("Standard", "Helvetica", 12, "Bold"),
                                        RectangleF(10, 10, 80, 20), None, Color(255, 0, 0, 0))
text3 = AnnotationApperanceText("Test Pressed! ", Font("Standard", "Helvetica", 12, "Bold"),
                                        RectangleF(10, 10, 80, 20), None, Color(255, 0, 0, 0))
image = AnnotationApperanceImage(PointF(50, 50), "Attachment.jpg")
apperance1 = AnnotationApperance(100, 100, text1, image)
apperance2 = AnnotationApperance(100, 100, text2, image)
apperance3 = AnnotationApperance(100, 100, text3, image)
annotation1 = RubberStampAnnotation(Color(100, 255, 0, 0), "Rubber stamp annotation test 1", None, None,
                                            "RubberStampAnnotation1", RectangleF(50, 50, 80, 80), 1, None,
                                            "RubberStamp1", None, None)

annotation2 = RubberStampAnnotation(Color(100, 0, 0, 255), "Rubber stamp annotation test 2", None, None,
                                            "RubberStampAnnotation2", RectangleF(50, 350, 100, 100), 1, None,
                                            "RubberStamp2", "Additional", apperance1, apperance2, apperance3)

annotationList = [annotation1, annotation2]
rubberStampAnnotations = RubberStampAnnotations(annotationList)
api.add_rubber_stamp_annotation(name, outputPath, pageNumber, rubberStampAnnotations, folder=inputFolder,password=password)