# coding: utf-8

"""
 Copyright(c) 2012-2020 E-ICEBLUE Spire.Cloud.Pdf
 
 This program is a free software product. You can redistribute it and/or modify it under the 
 terms of the GNU Affero General Public License (AGPL) version 3 as published by the Free 
 Software Foundation, including without limitation the rights to use, copy, modify, merge, 
 publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to 
 whom the Software is furnished to do so, subject to the following conditions:
  
 The above copyright notice and this permission notice shall be included in all copies or 
 substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 IMPLIED,INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE 
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 LIABILITY,WHETHER IN AN ACTION OF ONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER EALINGS IN THE 
 SOFTWARE.
"""

from enum import Enum

class CheckBoxFieldTestType(Enum):
    Required = 1 
    MappingName = 2
    ToolTip = 3
    Value = 4 

from spirecloudpdf.models.acroform.check_box_field import CheckBoxField
from spirecloudpdf.models.rectangle_f import RectangleF

class CheckBoxHelper(object):

    def get_checkBox_field(self,testtype):

        if testtype == CheckBoxFieldTestType.Required:
            return self.simple_checkBox_field()

        elif testtype == CheckBoxFieldTestType.MappingName:
            return self.mappingName_checkBox_field()
        
        elif testtype == CheckBoxFieldTestType.ToolTip:
            return self.toolTip_checkBox_field()

        elif testtype == CheckBoxFieldTestType.Value:
            return self.values_checkBox_field()

    def simple_checkBox_field(self):
        checkBoxFlags = []
        checkBoxFlags.append("NoExport")
        checkBoxFlags.append("Required")
        bounds = RectangleF(300, 500, 20, 20)
        name = "agreement_of_terms"
        pageIndex = 1
        return CheckBoxField(check_box_flags = checkBoxFlags, bounds = bounds,name = name, page_index = pageIndex)

    def mappingName_checkBox_field(self):
        checkBoxFlags = []
        checkBoxFlags.append("NoExport")
        checkBoxFlags.append("Required")
        bounds = RectangleF(300, 500, 20, 20)
        name = "agreement_of_terms"
        pageIndex = 1
        checkBox = CheckBoxField(check_box_flags = checkBoxFlags, bounds = bounds,name = name, page_index = pageIndex)
        checkBox.mapping_name = "CheckBoxMapingName"
        return checkBox

    def toolTip_checkBox_field(self):
        checkBoxFlags = []
        checkBoxFlags.append("NoExport")
        checkBoxFlags.append("Required")
        bounds = RectangleF(300, 500, 20, 20)
        name = "agreement_of_terms"
        pageIndex = 1
        checkBox =  CheckBoxField(check_box_flags = checkBoxFlags, bounds = bounds,name = name, page_index = pageIndex)
        checkBox.mapping_name = "CheckBoxMapingName"
        checkBox.tool_tip = "CheckBoxToolTip"
        return checkBox

    def values_checkBox_field(self):
        checkBoxFlags = []
        checkBoxFlags.append("NoExport")
        checkBoxFlags.append("Required")
        bounds = RectangleF(300, 500, 20, 20)
        name = "agreement_of_terms"
        pageIndex = 1
        checkBox =  CheckBoxField(check_box_flags = checkBoxFlags, bounds = bounds,name = name, page_index = pageIndex)
        checkBox.mapping_name = "CheckBoxMapingName"
        checkBox.tool_tip = "CheckBoxToolTip"
        checkBox.value = "true"
        return checkBox

    def required_attributies(self):
        checkBoxFlags = []
        checkBoxFlags.append("NoExport")
        checkBoxFlags.append("Required")
        bounds = RectangleF(300, 500, 20, 20)
        name = "agreement_of_terms"
        pageIndex = 1
        return CheckBoxField(check_box_flags = checkBoxFlags, bounds = bounds,name = name, page_index = pageIndex)


            

         
            





        

    





