# coding: utf-8

"""
 Copyright(c) 2012-2020 E-ICEBLUE Spire.Cloud.Pdf
 
 This program is a free software product. You can redistribute it and/or modify it under the 
 terms of the GNU Affero General Public License (AGPL) version 3 as published by the Free 
 Software Foundation, including without limitation the rights to use, copy, modify, merge, 
 publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to 
 whom the Software is furnished to do so, subject to the following conditions:
  
 The above copyright notice and this permission notice shall be included in all copies or 
 substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 IMPLIED,INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE 
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 LIABILITY,WHETHER IN AN ACTION OF ONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER EALINGS IN THE 
 SOFTWARE.
"""

from enum import Enum 


class ComboBoxFieldTestType(Enum):
    Required = 1
    MappingName = 2
    ToolTip = 3
    Values = 4
    SelectedIndexs = 5

from spirecloudpdf.models.acroform.combo_box_field import ComboBoxField
from spirecloudpdf.models.rectangle_f import RectangleF

class ComboBoxHelper(object):

    def get_combox_field(self,testtype):

        if   testtype == ComboBoxFieldTestType.Required:
            return self.SimpleComboBoxField()

        elif testtype == ComboBoxFieldTestType.MappingName:
            return self.MappingNameComboBoxField()

        elif testtype == ComboBoxFieldTestType.SelectedIndexs:
            return self.SelectedIndexsComboBoxField()

        elif testtype == ComboBoxFieldTestType.ToolTip:
            return self.ToolTipComboBoxField()
        
        elif testtype == ComboBoxFieldTestType.Values:
            return self.ValuesComboBoxField()

    def SimpleComboBoxField(self):
        comboBoxFlags = []
        comboBoxFlags.append("Edit")
        comboBoxFlags.append("CommitOnSelChange")
        bounds = RectangleF(100, 250, 150, 25)
        return ComboBoxField(comboBoxFlags, bounds, "title", 1)

    def MappingNameComboBoxField(self):
        comboBoxFlags = []
        comboBoxFlags.append("Edit")
        comboBoxFlags.append("CommitOnSelChange")
        bounds = RectangleF(100, 250, 150, 25)
        combox_field = ComboBoxField(comboBoxFlags, bounds, "title", 1)
        combox_field.mapping_name = "comboBoxMapingName"
        return combox_field

    def ToolTipComboBoxField(self):
        comboBoxFlags = []
        comboBoxFlags.append("Edit")
        comboBoxFlags.append("CommitOnSelChange")
        bounds = RectangleF(100, 250, 150, 25)
        combox_field = ComboBoxField(comboBoxFlags, bounds, "title", 1)
        combox_field.mapping_name = "comboBoxMapingName"
        combox_field.tool_tip = "comboBoxToolTip"
        return combox_field

    def ValuesComboBoxField(self):
        comboBoxFlags = []
        comboBoxFlags.append("Edit")
        comboBoxFlags.append("CommitOnSelChange")
        bounds = RectangleF(100, 250, 150, 25)
        combox_field = ComboBoxField(comboBoxFlags, bounds, "title", 1)
        combox_field.mapping_name = "comboBoxMapingName"
        combox_field.tool_tip = "comboBoxToolTip"
        combox_field.values = ["PDF", "XLS", "PPT", "DOC", "DOCX"]
        return combox_field

    def SelectedIndexsComboBoxField(self):
        comboBoxFlags = []
        comboBoxFlags.append("Edit")
        comboBoxFlags.append("CommitOnSelChange")
        bounds = RectangleF(100, 250, 150, 25)
        combox_field = ComboBoxField(comboBoxFlags, bounds, "title", 1)
        combox_field.mapping_name = "comboBoxMapingName"
        combox_field.tool_tip = "comboBoxToolTip"
        combox_field.values = ["PDF", "XLS", "PPT", "DOC", "DOCX"]
        combox_field.selected_indexs = [1,2]
        return combox_field













