# coding: utf-8

"""
 Copyright(c) 2012-2020 E-ICEBLUE Spire.Cloud.Pdf
 
 This program is a free software product. You can redistribute it and/or modify it under the 
 terms of the GNU Affero General Public License (AGPL) version 3 as published by the Free 
 Software Foundation, including without limitation the rights to use, copy, modify, merge, 
 publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to 
 whom the Software is furnished to do so, subject to the following conditions:
  
 The above copyright notice and this permission notice shall be included in all copies or 
 substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 IMPLIED,INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE 
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 LIABILITY,WHETHER IN AN ACTION OF ONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER EALINGS IN THE 
 SOFTWARE.
"""

from enum import Enum

class FieldTestType(Enum):
    Required = 1
    MappingName = 2
    ToolTip = 3
    SelectedItems = 4

from spirecloudpdf.models.acroform.field import Field
from spirecloudpdf.models.rectangle_f import RectangleF

class FieldHelper(object):

    def get_field(self,ftype,testtype):

        self.f_type = ftype
        if   testtype == FieldTestType.Required:
            return self.SimpleField()

        elif testtype == FieldTestType.MappingName:
            return self.MappingNameField()
        
        elif testtype == FieldTestType.ToolTip:
            return self.ToolTipField()

        elif testtype == FieldTestType.SelectedItems:
            return self.SelectedItemsField()

    def SimpleField(self):

        values = []
        if   self.f_type == "Check":
            values.append("true")

        elif self.f_type == "PushButton":
            values.append("Push It")

        else:
            values.append("alibaba")

        values.append("tencent")
        values.append("apple")
        values.append("google")

        bounds = RectangleF(300, 500, 150, 60)
        name = self.get_field_name()

        if self.f_type == "Check":
            bounds = RectangleF(300, 500, 15, 15)

        if self.f_type == "PushButton":
            bounds = RectangleF(300, 500, 40, 22)

        return Field(bounds, values, name, self.f_type, 1)

    def  get_field_name(self):
        if  self.f_type == "Text":
            return "state"
            
        elif self.f_type  == "Check":
            return "agreement_of_terms"

        elif self.f_type  == "List":
            return "email_format"

        elif self.f_type  == "ComboBox":
            return "title"

        elif self.f_type  == "PushButton":
            return "submit"

    def MappingNameField(self):
        values = []
        if   self.f_type == "Check":
            values.append("true")

        elif self.f_type == "PushButton":
            values.append("Push It")

        else:
            values.append("alibaba")

        values.append("tencent")
        values.append("apple")
        values.append("google")

        bounds = RectangleF(300, 500, 150, 60)
        name = self.get_field_name()

        if self.f_type == "Check":
            bounds = RectangleF(300, 500, 15, 15)

        if self.f_type == "PushButton":
            bounds = RectangleF(300, 500, 40, 22)

        field = Field(bounds, values, name, self.f_type, 1)
        field.mapping_name = self.f_type + "MapingName"
        return field

    def ToolTipField(self):
        values = []
        if   self.f_type == "Check":
            values.append("true")

        elif self.f_type == "PushButton":
            values.append("Push It")

        else:
            values.append("alibaba")

        values.append("tencent")
        values.append("apple")
        values.append("google")

        bounds = RectangleF(300, 500, 150, 60)
        name = self.get_field_name()

        if self.f_type == "Check":
            bounds = RectangleF(300, 500, 15, 15)

        if self.f_type == "PushButton":
            bounds = RectangleF(300, 500, 40, 22)

        field = Field(bounds, values, name, self.f_type, 1)
        field.mapping_name = self.f_type + "MapingName"
        field.tool_tip = self.f_type + "ToolTip"

        return field

    def SelectedItemsField(self):
        values = []
        if   self.f_type == "Check":
            values.append("true")

        elif self.f_type == "PushButton":
            values.append("Push It")

        else:
            values.append("alibaba")

        values.append("tencent")
        values.append("apple")
        values.append("google")

        bounds = RectangleF(300, 500, 150, 60)
        name = self.get_field_name()

        if self.f_type == "Check":
            bounds = RectangleF(300, 500, 15, 15)

        if self.f_type == "PushButton":
            bounds = RectangleF(300, 500, 40, 22)

        field = Field(bounds, values, name, self.f_type, 1)
        field.mapping_name = self.f_type + "MapingName"
        field.tool_tip = self.f_type + "ToolTip"
        field.selected_items = [0,2]
        return field

    








    

        



