# coding: utf-8

"""
 Copyright(c) 2012-2020 E-ICEBLUE Spire.Cloud.Pdf
 
 This program is a free software product. You can redistribute it and/or modify it under the 
 terms of the GNU Affero General Public License (AGPL) version 3 as published by the Free 
 Software Foundation, including without limitation the rights to use, copy, modify, merge, 
 publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to 
 whom the Software is furnished to do so, subject to the following conditions:
  
 The above copyright notice and this permission notice shall be included in all copies or 
 substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 IMPLIED,INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE 
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 LIABILITY,WHETHER IN AN ACTION OF ONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER EALINGS IN THE 
 SOFTWARE.
"""

from enum import Enum 

class PushButtonFieldTestType(Enum):
    Required = 1
    MappingName = 2
    ToolTip = 3
    Value = 4

from spirecloudpdf.models.acroform.push_button_field import PushButtonField
from spirecloudpdf.models.rectangle_f import RectangleF

class PushButtonHelper(object):

    def get_pushbutton_field(self,testtype):
        if testtype == PushButtonFieldTestType.Required:
            return self.SimplePushButtonField()
        
        elif testtype == PushButtonFieldTestType.MappingName:
            return self.MappingNamePushButtonField()

        elif testtype == PushButtonFieldTestType.ToolTip:
            return self.ToolTipPushButtonField()

        elif testtype == PushButtonFieldTestType.Value:
            return self.ValuesPushButtonField()

    def SimplePushButtonField(self):
        pushButtonFlags = []
        pushButtonFlags.append("NoExport")
        pushButtonFlags.append("Required")
        bounds = RectangleF(300, 500, 50, 25)
        return PushButtonField(pushButtonFlags, "submit", 1, bounds)

    def MappingNamePushButtonField(self):
        pushButtonFlags = []
        pushButtonFlags.append("NoExport")
        pushButtonFlags.append("Required")
        bounds = RectangleF(300, 500, 50, 25)
        pushbutton = PushButtonField(pushButtonFlags, "submit", 1, bounds)
        pushbutton.mapping_name = "PushButtonMapingName"
        return pushbutton

    def ToolTipPushButtonField(self):
        pushButtonFlags = []
        pushButtonFlags.append("NoExport")
        pushButtonFlags.append("Required")
        bounds = RectangleF(300, 500, 50, 25)
        pushbutton = PushButtonField(pushButtonFlags, "submit", 1, bounds)
        pushbutton.mapping_name = "PushButtonMapingName"
        pushbutton.tool_tip = "PushButtonToolTip"
        return pushbutton

    def ValuesPushButtonField(self):
        pushButtonFlags = []
        pushButtonFlags.append("NoExport")
        pushButtonFlags.append("Required")
        bounds = RectangleF(300, 500, 50, 25)
        pushbutton = PushButtonField(pushButtonFlags, "submit", 1, bounds)
        pushbutton.mapping_name = "PushButtonMapingName"
        pushbutton.tool_tip = "PushButtonToolTip"
        pushbutton.value = "Push It"
        return pushbutton









