# coding: utf-8

"""
 Copyright(c) 2012-2020 E-ICEBLUE Spire.Cloud.Pdf
 
 This program is a free software product. You can redistribute it and/or modify it under the 
 terms of the GNU Affero General Public License (AGPL) version 3 as published by the Free 
 Software Foundation, including without limitation the rights to use, copy, modify, merge, 
 publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to 
 whom the Software is furnished to do so, subject to the following conditions:
  
 The above copyright notice and this permission notice shall be included in all copies or 
 substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 IMPLIED,INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE 
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 LIABILITY,WHETHER IN AN ACTION OF ONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER EALINGS IN THE 
 SOFTWARE.
"""

from enum import Enum

class RadioButtonFieldTestType(Enum):
    Required = 1
    MappingName = 2
    ToolTip = 3 
    SelectedIndexs = 4

from spirecloudpdf.models.acroform.radio_button_field import RadioButtonField
from spirecloudpdf.models.acroform.radio_button_option_field import RadioButtonOptionField
from spirecloudpdf.models.rectangle_f import RectangleF

class RadioButtonHelper(object):

    def get_radiobutton_field(self,testtype):
        if   testtype == RadioButtonFieldTestType.Required:
            return self.SimpleRadioButtonField()

        elif testtype == RadioButtonFieldTestType.MappingName:
            return self.MappingNameRadioButtonField()

        elif testtype == RadioButtonFieldTestType.ToolTip:
            return self.ToolTipRadioButtonField()

        elif testtype == RadioButtonFieldTestType.SelectedIndexs:
            return self.SelectedIndexsRadioButtonField()

    def SimpleRadioButtonField(self):

        radioButtonFlags = []
        radioButtonFlags.append("NoExport")
        radioButtonFlags.append("Required")
        values = ["PDF", "XLS", "PPT"]
        options = []

        for i in range(3):
            bounds = RectangleF(300 + 20 * i, 500, 10, 10)
            Value = values[i]
            RrdioButtonOptionField = RadioButtonOptionField(bounds, Value)
            options.append(RrdioButtonOptionField)
        
        radioButton =  RadioButtonField(1,radioButtonFlags, "country", options)
        radioButton.value = values
        return radioButton

    def MappingNameRadioButtonField(self):

        radioButtonFlags = []
        radioButtonFlags.append("NoExport")
        radioButtonFlags.append("Required")
        values = ["PDF", "XLS", "PPT"]
        options = []

        for i in range(3):
            bounds = RectangleF(300 + 20 * i, 500, 10, 10)
            Value = values[i]
            RrdioButtonOptionField = RadioButtonOptionField(bounds, Value)
            options.append(RrdioButtonOptionField)
        
        radioButton =  RadioButtonField(1,radioButtonFlags, "country", options)
        radioButton.value = values
        radioButton.mapping_name = "RadioButtonMapingName"
        return radioButton

    def ToolTipRadioButtonField(self):

        radioButtonFlags = []
        radioButtonFlags.append("NoExport")
        radioButtonFlags.append("Required")
        values = ["PDF", "XLS", "PPT"]
        options = []

        for i in range(3):
            bounds = RectangleF(300 + 20 * i, 500, 10, 10)
            Value = values[i]
            RrdioButtonOptionField = RadioButtonOptionField(bounds, Value)
            options.append(RrdioButtonOptionField)
        
        radioButton =  RadioButtonField(1,radioButtonFlags, "country", options)
        radioButton.value = values
        radioButton.mapping_name = "RadioButtonMapingName"
        radioButton.tool_tip = "RadioButtonToolTip"
        return radioButton

    def SelectedIndexsRadioButtonField(self):

        radioButtonFlags = []
        radioButtonFlags.append("NoExport")
        radioButtonFlags.append("Required")
        values = ["PDF", "XLS", "PPT"]
        options = []

        for i in range(3):
            bounds = RectangleF(300 + 20 * i, 500, 10, 10)
            Value = values[i]
            RrdioButtonOptionField = RadioButtonOptionField(bounds, Value)
            options.append(RrdioButtonOptionField)
        
        radioButton =  RadioButtonField(1,radioButtonFlags, "country", options)
        radioButton.value = values
        radioButton.mapping_name = "RadioButtonMapingName"
        radioButton.tool_tip = "RadioButtonToolTip"
        radioButton.selected_index = 1
        return radioButton











